/*
	Biribot.h
*/

typedef struct 
{
  int indice;
  float distancia;
} VECTOR;


#define FOREVER for(;;)
#define PAUSE_1 delay(1000)
#define PAUSE_2 delay(2000)
#define PAUSE_5 delay(5000)


#define NO                    0
#define SI                  !NO
#define ERR                  -1


// Speeds & delays
#define V_MIN                10
#define V_MAX                80
#define V_TEST               25
#define V_ACT                60    
#define V_ROT                30

#define D_MOV                 0
#define DT_NEUTRAL           25
#define DT_ROTATE             0


// Directions
#define STOP                  0
#define FORWARD               1
#define REVERSE               2
#define LEFT                  3
#define RIGHT                 4
#define LEFT_FW               5     
#define LEFT_RV               6
#define RIGHT_FW              7
#define RIGHT_RV              8



// Interface with hardware

//  Motors ( Servos)
#define LM_PIN                9    //  Left motor    White, Orange
#define RM_PIN               10    //  Right motor   Yellow


//  HCSR04 Ultrasonic sensor
// Used in Read__distance() HCSR04 function
#define HCSR04_K             80.0       //  The standard is 58.0 In my sensor this is the correct value
#define HCSR04_TRIG_PIN      11       //  Trigger             Yellow
#define HCSR04_ECHO_PIN      12       //  Echo                Orange
#define HCSR04_PULSEWIDTH    10       //  Trigger pulse width ( microsegs )

#define DIST_HORIZONTE       15.0
#define DIST_MIN_MAX         12.0     //  Biribot will stop when he gets to this distance ...
#define DIST_MIN_MIN          5.0     //    ... and will move forward slower until he gets this distance
#define DIST_ERR              2.0     //  Not used
#define NUM_DEC               2       //  Number of decs for IMprime()


// Servos center positions ( Should be 90 but what can you expect of a 2 bucks Chinese servo? Centered at 90 ?? Hahaha )
#define LM_CENTER            80
#define RM_CENTER            83



/*
    Prototypes
*/

float  Read_distance(void);
void Imprime( float );            //Imprime = Print in Spanish

void Moveto_normal(void);
int Are_near( float a, float b);


void Engine_start( void );
void Engine_stop( void );


void Move( int , int );
void Turn( int , int );
void Rotate( int , int );
void Neutral( void );
void Change( int , int , int );   // Only definition. We need a declaration ( the function itself )
void lm_move( int , int );
void rm_move( int , int );

void LM_Test( void );
void RM_Test( void );
void Drivetrain_test( void );




